/* pour éviter que le précompilateur 
   inclue plusieurs fois le fichier .h */
#ifndef PILE_PTR_H  
#define PILE_PTR_H
#include <stdbool.h>
/* Définir à la compilation de TYPE 
   p.ex. gcc -c -D TYPE=int pile_ptr.h pile_ptr.c */
typedef TYPE info;
/* Utilité du typedef : 
   Element a; <=> struct Element a; */
typedef struct _element {
   info data;
   struct _element* next;
} element;
typedef element* pile;

//Créer d'une nouvelle pile vide
pile pile_creer();
//Désallouer complètement la pile
void pile_detruire(pile* stack);
//Empiler un élement en début de pile
void pile_empiler(pile* stack,info val);
//Dépiler un élément de la pile
info pile_depiler(pile* stack);
//Consulter l'élément au sommet de la pile
info pile_sommet(pile stack);
//Tester si la pile est vide
bool pile_est_vide(pile stack);
//Compter le nombre d'éléments de la pile:
int pile_count(pile stack);
#endif

